Subject: bug#69404: Loss of latex-mode fontification when loading libraries in latex-mode-hook that require json-mode

From: Gabriele Nicolardi <[email-masked]>
Date: Mon, 26 Feb 2024 16:41:15 +0100

Il 26/02/24 14:03, Eli Zaretskii ha scritto:
>> Date: Mon, 26 Feb 2024 10:27:53 +0100
>> From: Gabriele Nicolardi <[email-masked]>
>>
>> I have a LaTeX file:
>>
>> \documentclass{article}
>> \usepackage{mwe}
>> \begin{document}
>>
>> \blindtext
>>
>> \noindent
>> \includegraphics[width=.4\textwidth]{example-image-a}\hfill
>> \includegraphics[width=.4\textwidth]{example-image-b}
>>
>> \blindtext
>>
>> \end{document}
>>
>> If I load it like this:
>>
>> emacs -Q test.tex
>>
>> I get this “correct” latex-mode fontification:
>>
>> I have also a config file (I simplified it to obtain the feature):
>>
>> (add-hook 'latex-mode-hook
>>            #'(lambda ()
>>            (package-initialize)
>>            (require 'json-mode)))
>>
>> If I load my .tex file like this:
>>
>> emacs -Q --eval "(load-file \"/tmp/config.el\")" test.tex
>>
>> I lose latex-mode fontification:
> What is the value of major-mode after you load your .tex file as
> above?

In the buffer loaded as above, with the wrong fontification, I have:

major-mode is a variable defined in ‘C source code’.

Its value is ‘latex-mode’
Original value was ‘fundamental-mode’
Local in buffer test.tex; global value is fundamental-mode